#include "Utils.hh"
#include <string>

double dmsToDec(std::string input)
{
  /** 
   *  double dmsToDec(string)
   *   Converts a string in the format +12:23:34.45 to a decimal angle in 
   *    degrees.
   *   Assumes the angle given is in degrees, so if passing RA as the argument,
   *   need to multiply by 15 to get the result in degrees rather than hours.
   *   The sign of the angle is preserved, if present.
   */

  std::string dms = removeLeadingBlanks(input);

  bool isNeg = false;
  if(dms[0]=='-') isNeg = true;

  for(int i=0;i<dms.size();i++) if(dms[i]==':') dms[i]=' ';

  std::stringstream ss;
  ss.str(dms);

  std::string deg,min,sec;
  getline(ss,deg,' ');
  getline(ss,min,' ');
  getline(ss,sec);
  char *end;
  double d = strtod(deg.c_str(),&end);
  double m = strtod(min.c_str(),&end);
  double s = strtod(sec.c_str(),&end);  

  double dec = fabs(d) + m/60. + s/3600.;
  if(isNeg) dec = dec * -1.;

  return dec;

}
