#ifndef UTILS_HH_
#define UTILS_HH_
#include <sstream>
#include <string>
#include <vector>

inline std::string removeLeadingBlanks(std::string s)
{
  int i=0;
  while(s[i]==' '){
    i++;
  }
  std::string newstring;
  for(int j=i;j<s.size();j++) newstring += s[j];
  return newstring;
}

inline std::string charToBinary(char c)
{
  std::stringstream ss;
  int num=c;
  if (num<0) num+=256;
  int factor = 128;
  for(int i=0;i<8;i++){
    ss << num/factor;
    num -= num/factor * factor;
    factor /= 2;
  }
  return ss.str();
}

inline std::string binaryToString(std::vector<bool> v)
{
  int size = v.size();
  int nbytes = (size-1)/8 + 1;
  std::string output;
  for(int byte=0;byte<nbytes;byte++){
    int c=0;
    for(int bit=0;bit<8;bit++){
      int pt = byte*8+bit;
      if(v[pt]) c += int(pow(2,7-bit));
    }
    //    std::cerr << int(c) << std::endl;
    output += char(c);
  }
  return output;
}

inline unsigned int * binaryToInt(std::vector<bool> v)
{
  int size = v.size();
  int nbytes = (size-1)/8 + 1;
  unsigned int *output = new unsigned int[nbytes];
  for(int byte=0;byte<nbytes;byte++){
    int c=0;
    for(int bit=0;bit<8;bit++){
      int pt = byte*8+bit;
      if(v[pt]) c += (unsigned int)pow(2,7-bit);
    }
    //    std::cerr << c << std::endl;
    output[byte] = c;
  }
  return output;
}

inline std::string getPSRFITSdefn()
{
  std::string defn = getenv("PSRFITSDEFN");
  return defn;
}

double dmsToDec(std::string input);  // in Utils.cc

#endif /*UTILS_HH_*/
