#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include "../Block.hh"
#include "../Header.hh"
#include "../Utils.hh"

using namespace Header;
using namespace Block;
using std::string;
using std::vector;

int main()
{

  DataBlock block("S70");
  std::ifstream fin;
  fin.open("data/s70_tape_test_S181_S18101.dat",std::ios::binary);
  block.readBlock(fin);

  int numFilters = block.getKeyword<int>(NFILTER);
  std::cout << "Number of filters = " << numFilters<<"\n";
  vector<int> numChannels = block.getFullKeyword<int>(NCHAN);
  for(int filt=0;filt<numFilters;filt++)
    std::cout << "Number of channels in filter #" << filt + 1
	      << " = " << numChannels[filt]<<"\n";

  int numPerSample=0;
  for(int filt=0;filt<numFilters;filt++) numPerSample += numChannels[filt];

  int datapt = 0;
  for(int sample=0;sample<10;sample++){

    for(int filt=0;filt<numFilters;filt++){
      
      for(int chan=0;chan<numChannels[filt]/8;chan++){

	char c = block.getDatum(datapt++);
	std::cout << charToBinary(c);
	if((chan+1)%(numChannels[filt]/16) == 0) std::cout << "\n";

      }
      std::cout << " ";
 
    }
    std::cout << "\n\n";

  }				


}
